/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Get data for invoice creation download
*/

CREATE PROCEDURE [dbo].[SP_DLV_INV_CreationGridData]
   @DOCDATEFROM VARCHAR(MAX),
   @DOCDATETO VARCHAR(MAX),
   @DELIVERYNO VARCHAR(MAX),
   @LPCD VARCHAR(MAX),
   @DELIVERY_NO2 VARCHAR(MAX),
   @PO_NO VARCHAR(MAX),
   @ShowUploaded varchar(max)
AS
BEGIN
	DECLARE @sql VARCHAR (MAX);
	DECLARE @DOC_DATE_FROM VARCHAR(13) = @DOCDATEFROM;
	DECLARE @DOC_DATE_TO VARCHAR (MAX) = @DOCDATETO;
	DECLARE @DELIVERY_NO VARCHAR (MAX) = @DELIVERYNO;
	DECLARE @LP_CD VARCHAR (MAX) = @LPCD;
	DECLARE @DLVN varchar(MAX)='';
	DECLARE @PN varchar(MAX) = '';


	DECLARE @v XML;
	SET @v = '<r>' + REPLACE((SELECT @DELIVERY_NO2 FOR XML PATH('')), ',', '</r><r>') + '</r>';

	select Value into #getReffNo from(SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(MAX)') AS Value FROM    @v.nodes('/r') y(XmlCol))tbl;
	DECLARE @DLV_NO varchar(15);
	DECLARE DLVN_CUR CURSOR
	FOR 
	SELECT Value FROM #getReffNo;
	OPEN DLVN_CUR;
	FETCH NEXT FROM DLVN_CUR INTO @DLV_NO;
	
	WHILE @@FETCH_STATUS = 0  
	BEGIN  
		
		SET @DLVN = @DLVN+''''+@DLV_NO+''','
		FETCH NEXT FROM DLVN_CUR INTO @DLV_NO;
	END;
	CLOSE DLVN_CUR;
	DEALLOCATE DLVN_CUR;
	drop table #getReffNo;
		
		
		
		
		
	DECLARE @w XML;
	SET @w = '<r>' + REPLACE((SELECT @PO_NO FOR XML PATH('')), ',', '</r><r>') + '</r>';

	select Value into #getPO from(SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(MAX)') AS Value FROM    @w.nodes('/r') y(XmlCol))tbl;
	DECLARE @PONO varchar(15);
	DECLARE PO_CUR CURSOR
	FOR 
	SELECT Value FROM #getPO;
	OPEN PO_CUR;
	FETCH NEXT FROM PO_CUR INTO @PONO;
	
	WHILE @@FETCH_STATUS = 0  
	BEGIN  
		
		SET @PN = @PN+''''+@PONO+''','
		FETCH NEXT FROM PO_CUR INTO @PONO;
	END;
	CLOSE PO_CUR;
	DEALLOCATE PO_CUR;
	drop table #getPO;
	



	--SET @sql ='
	--SELECT ''200'' as ClientID, a.LP_CD, a.PO_NO, a.PO_ITEM_NO, c.ROUTE_CD, a.REFF_NO, a.COMP_PRICE_CD, CONVERT(VARCHAR(20), a.DOC_DT, 104) as DOC_DT, c.TRANSACTION_QTY, b.LP_INV_NO, a.PO_DETAIL_PRICE, c.TRANSACTION_CURR, CAST((c.TRANSACTION_QTY * a.PO_DETAIL_PRICE) as numeric(15,2)) as AMOUNT FROM TB_R_DLV_GR_IR a
	--LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO
	--LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
	--WHERE 1=1 AND CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = ''H'' '

--SET @sql ='
--	SELECT ''200'' as ClientID, a.LP_CD, a.PO_NO, a.PO_ITEM_NO, c.ROUTE_CD, a.REFF_NO, a.COMP_PRICE_CD, CONVERT(VARCHAR(20), a.DOC_DT, 104) as DOC_DT, c.TRANSACTION_QTY, b.LP_INV_NO, convert(varchar,cast(a.GR_IR_AMT as money),-1) as PO_DETAIL_PRICE, c.TRANSACTION_CURR, convert(varchar,cast(a.PO_DETAIL_PRICE as money),-1) as AMOUNT FROM TB_R_DLV_GR_IR a
--	LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO
--	LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
--	WHERE 1=1 AND CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = ''H'' '

	--SET @sql = 'SELECT ''200'' as ClientID, a.LP_CD, a.PO_NO, a.PO_ITEM_NO, c.ROUTE_CD, a.REFF_NO, a.COMP_PRICE_CD, CONVERT(VARCHAR(20), a.DOC_DT, 104) as DOC_DT, c.TRANSACTION_QTY, b.LP_INV_NO, convert(varchar,cast(a.PO_DETAIL_PRICE as money),-1) as PO_DETAIL_PRICE, c.TRANSACTION_CURR, convert(varchar,cast(a.GR_IR_AMT as money),-1) as AMOUNT FROM TB_R_DLV_GR_IR a
	--LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO AND b.CONDITION_CATEGORY = a.CONDITION_CATEGORY
	--LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
	--WHERE 1=1 AND CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = ''H'' AND a.STATUS_CD NOT IN (2) '
	
	SET @sql = 'SELECT ''200'' as ClientID, a.LP_CD, a.PO_NO, a.PO_ITEM_NO, c.ROUTE_CD, a.REFF_NO, a.COMP_PRICE_CD, CONVERT(VARCHAR(20), a.DOC_DT, 104) as DOC_DT, c.TRANSACTION_QTY, b.LP_INV_NO, convert(varchar,cast(a.PO_DETAIL_PRICE as money),-1) as PO_DETAIL_PRICE, c.TRANSACTION_CURR, convert(varchar,cast(a.GR_IR_AMT as money),-1) as AMOUNT FROM TB_R_DLV_GR_IR a
	LEFT JOIN TB_R_DLV_INV_UPLOAD b ON b.PO_NO = a.PO_NO AND b.DELIVERY_NO = a.REFF_NO AND b.CONDITION_CATEGORY = a.CONDITION_CATEGORY AND b.STATUS_CD IN (''1'', ''-1'')
	LEFT JOIN TB_R_DLV_SERVICE_DOC c ON c.SERVICE_DOC_NO = a.SERVICE_DOC_NO
	LEFT JOIN TB_M_LOGISTIC_PARTNER LP ON LP.LOG_PARTNER_CD = c.LP_CD
	WHERE 1=1 AND CANCEL_STS IS NULL AND a.CONDITION_CATEGORY = ''H'' AND a.STATUS_CD IN (1, -2) '

	IF(@DOC_DATE_FROM <> '' AND @DOC_DATE_TO IS NULL)
	BEGIN
		set @sql = @sql + 'AND a.DOC_DT = '+@DOC_DATE_FROM+' '
	END
	ELSE
	BEGIN
		set @sql = @sql + 'AND (a.DOC_DT BETWEEN '+@DOC_DATE_FROM+' AND '+@DOC_DATE_TO+' ) '
	END

if(@ShowUploaded = 'yes')
BEGIN
	set @sql = @sql + 'AND a.LIV_FLAG = 1 '
END


if(@LP_CD <> '')
	set @sql = @sql + 'AND a.LP_CD IN ('+ cast (@LP_CD as varchar (max)) +') '

if(@DELIVERY_NO2 <> '')
BEGIN
	set @sql = @sql + 'AND a.REFF_NO IN ('+SUBSTRING(@DLVN,1,LEN(@DLVN)-1)+') '
END
ELSE
BEGIN
	if(@DELIVERY_NO <> '')
		set @sql = @sql + 'AND a.REFF_NO LIKE ''%' + @DELIVERY_NO + '%'''
END

if (@LP_CD <> '') OR (@DELIVERY_NO <> '') OR (@DOC_DATE_FROM <> '' AND @DOC_DATE_TO <>'') OR @DELIVERY_NO2 <> '' OR @PO_NO <> ''
	EXEC (@sql);

END

